import { useRef, useEffect } from 'react';

var useIonHeaderCollapse = function useIonHeaderCollapse(_ref) {
  var _ref$marginBottom = _ref.marginBottom,
      marginBottom = _ref$marginBottom === void 0 ? 2 : _ref$marginBottom,
      _ref$openSpeedRate = _ref.openSpeedRate,
      openSpeedRate = _ref$openSpeedRate === void 0 ? 8 : _ref$openSpeedRate,
      _ref$closeSpeedRate = _ref.closeSpeedRate,
      closeSpeedRate = _ref$closeSpeedRate === void 0 ? 4 : _ref$closeSpeedRate;
  var ref = useRef(null);
  useEffect(function () {
    setTimeout(function () {
      return initElements();
    }, 300);
  }, [ref]);

  var initElements = function initElements() {
    if (ref && ref.current) {
      var _ionContent$shadowRoo;

      var header = ref.current;
      var parentElement = header.parentElement;
      if (!parentElement) throw new Error('No IonPage parent element');
      var ionContent = parentElement.querySelector('ion-content');
      if (!ionContent) throw new Error('Parallax requires an <ion-content> element on the page to work.');
      var scrollContent = (_ionContent$shadowRoo = ionContent.shadowRoot) === null || _ionContent$shadowRoo === void 0 ? void 0 : _ionContent$shadowRoo.querySelector('.inner-scroll');

      if (!scrollContent) {
        throw new Error('Parallax directive requires an <ion-content> element on the page to work.');
      }

      if (scrollContent) {
        var ionHeader = parentElement.querySelector('ion-header');
        var previousScrollTop = 0;
        var contentHeight = ionHeader.scrollHeight + marginBottom;
        var scrollProcess = 0;
        scrollContent.addEventListener('scroll', function (_e) {
          var scrollTop = scrollContent.scrollTop;

          if (scrollTop > previousScrollTop) {
            if (scrollProcess < contentHeight) {
              scrollProcess += closeSpeedRate;
              ionHeader.style.setProperty('bottom', scrollProcess + "px");
            }
          } else {
            if (scrollProcess > 0) {
              scrollProcess -= openSpeedRate;
              scrollProcess = scrollProcess < 0 ? 0 : scrollProcess;
              ionHeader.style.setProperty('bottom', scrollProcess + "px");
            }
          }

          previousScrollTop = scrollTop;
        });
      }
    }
  };

  return {
    ref: ref
  };
};

export { useIonHeaderCollapse };
//# sourceMappingURL=index.modern.js.map
